#include <string.h>

#include <gui.h>

void print_top (char *text)
{
	int i;

	set_color(1);
	printw("%s", text);
	for (i=strlen(text);i<COLS;i++)
		addch(' ');
	set_color(0);
}

void init_gui ()
{
	initscr();
	start_color();
	noecho();
	curs_set(0);
	
	init_pair(0, COLOR_WHITE, COLOR_BLACK);
	init_pair(1, COLOR_BLACK, COLOR_WHITE);
	st_tmp=0;
}

void scrtxt (char *text, int line, int color)
{
	int i, wrap;
	
	st_tmp++;
	if (st_tmp>COLS-1)
		st_tmp=0;
	
	set_color(color);
	move(line, st_tmp);
	if (st_tmp+strlen(text)<COLS)
		printw("%s", text);
	else
	{
		wrap=st_tmp+strlen(text)-COLS;
		for (i=0;i<strlen(text)-wrap;i++)
			addch(text[i]);
		move(line, 0);
		for (i=strlen(text)-wrap;i<strlen(text);i++)
			addch(text[i]);
	}	
	set_color(0);
}
