/* 	
	For writing strkill and strrep I was inspired by libowfat's textcode API
	(http://www.fefe.de/lowfat).
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <str.h>

/* Helper functions */
int starts (char *str, int begin, char *test)
{
	char *tmp;
	int ret=0;

	if (strlen(str)<begin+strlen(test))
		return 0;

	tmp=strcut(str, begin, strlen(test));

	if (!strcmp(tmp, test))
		ret=1;

	free(tmp);
	return ret;
}


char *strdog (char *str1, char *str2)
{
	char *ret=(char *)malloc(strlen(str1)+strlen(str2)+1);

	strcpy(ret, str1);
	strcat(ret, str2);
	return ret;
}

char *strcut (char *str, int begin, int count)
{
	int i, j=0, end;
	char *ret=(char *)malloc(count+1);

	if (strlen(str)<begin+count)
		end=strlen(str);
	else
		end=begin+count;
	
	for (i=begin;i<begin+count;i++)
		if (!((j==0)&&(str[i]==' ')))
		{
			ret[j]=str[i];
			j++;
		}
	ret[j]='\0';

	return ret;
}

int strcnt (char *str, char *sstr)
{
	char *t=(char *)malloc(strlen(str)+1), *t2;
	int i, ret=0;

	strcpy(t, str);
	t2=t;
	while (t)
	{
		t=strstr(t, sstr);
		if (t)
		{
			ret++;
			for (i=0;i<strlen(sstr);i++)
				t++;
		}
	}

	free(t2);
	return ret;
}

char *strrep (char *str, char *old, char *new)
{
	char *ret=(char *)malloc(strlen(str)+1+((strlen(new)-strlen(old))*
			strcnt(str, old)));
	int i, j=0, k;

	for (i=0;i<strlen(str);i++)
		if (starts(str, i, old))
		{
			for (k=j;k<j+strlen(new);k++)
				ret[k]=new[k-j];
			i+=strlen(old)-1;
			j+=strlen(new);
		}
		else
		{
			ret[j]=str[i];
			j++;
		}
	ret[j]='\0';

	return ret;
}

char *strkill (char *str, char *tokill)
{
	char *cpy=(char *)malloc(strlen(str)+1);
	int i, j=0;

	for (i=0;i<strlen(str);i++)
		if (starts(str, i, tokill))
			i+=strlen(tokill)-1;
		else
		{
			cpy[j]=str[i];
			j++;
		}
	cpy[j]='\0';

	return cpy;
}

char *chrep (char *str, char old, char new)
{
	char *ret=(char *)malloc(strlen(str)+1);
	int i;

	for (i=0;i<strlen(str);i++)
		if (str[i]==old)
			ret[i]=new;
		else
			ret[i]=str[i];
	ret[i]='\0';

	return ret;
}
