#include <string.h>

#include <str.h>
#include <rss-handler.h>

/* RSS header testcase */

void dump_header (feed fd)
{
	printf ("Title: %s\n", fd.title);
	printf ("URL: %s\n", fd.furl);
	printf ("Description: %s\n", fd.desc);
}

int main (int argc, char **argv)
{
	int ret;
	feed fd;

	rss_init_cache(&fd, "../../etc/cache/slashdot");
	ret=strcmp(fd.title, "Slashdot");
	ret+=strcmp(fd.furl, "");
	ret+=strcmp(fd.desc, "News for nerds, stuff that matters");
	rss_end(&fd);

	rss_init_cache(&fd, "../../etc/cache/empty.rdf");
	ret+=strcmp(fd.title, "Atzo");
	ret+=strcmp(fd.furl, "");
	ret+=strcmp(fd.desc, "wumbo mumbo");
	rss_end(&fd);

	rss_init_cache(&fd, "../../etc/cache/zeldman.xml");
	ret+=strcmp(fd.title, "Jeffrey Zeldman Presents: The Daily Report");
	ret+=strcmp(fd.furl, "");
	ret+=strcmp(fd.desc, "Web design news, info, and insights since 1995. CSS layout, XHTML, usability, accessibility. Designing with web standards. ISSN #1534-0309.");
	rss_end(&fd);

	rss_init_cache(&fd, "../../etc//cache/page-rdf-news.php");
	ret+=strcmp(fd.title, "Holarse - Spielen unter Linux");
	ret+=strcmp(fd.furl, "");
	ret+=strcmp(fd.desc, "Linuxspiele");
	rss_end(&fd);
	
	return ret;
}
