#ifndef __TST_H
#define __TST_H

#ifdef __cplusplus
extern "C" {
#endif

/** Generic test function
@param result Result of the function to test
@param reference The expected test result
@return 0 on success, positive value on failure
*/
int tst_harness (char *result, char *reference);
/** Generic test function
@param result Result of the function to test
@param reference The expected test result
@param count Compare 'count' characters
@return 0 on success, positive value on failure
*/
int tst_nharness (char *result, char *reference, int count);

#ifdef __cplusplus
}
#endif
#endif
